package com.example.demo2javafx;

import javafx.animation.ParallelTransition;
import javafx.animation.Transition;
import javafx.animation.TranslateTransition;
import javafx.event.ActionEvent;
import javafx.event.EventHandler;
import javafx.scene.Parent;
import javafx.scene.Scene;
import javafx.scene.control.Button;
import javafx.scene.control.Label;
import javafx.scene.control.TextField;
import javafx.scene.layout.BorderPane;
import javafx.scene.layout.FlowPane;
import javafx.scene.layout.HBox;
import javafx.scene.paint.Color;
import javafx.scene.shape.Rectangle;
import javafx.util.Duration;

public class RectangleScene {

    private Scene scene;
    private BorderPane pane;
    private Rectangle box;
    private static final int BOX_X = 100;
    private static final int BOX_Y = 100;
    private static final int BOX_WIDTH = 20;
    private static final int BOX_HEIGHT = 30;
    private static final int PANEL_WIDTH = 300;
    private static final int PANEL_HEIGHT = 300;

    public RectangleScene() {
        pane = new BorderPane();
        scene = new Scene(pane, PANEL_WIDTH, PANEL_HEIGHT);

        box = new Rectangle(BOX_X, BOX_Y, BOX_WIDTH, BOX_HEIGHT);
        box.setStroke(Color.BLUE);
        pane.setCenter(box);

        createControlPane();
    }

    public void createControlPane() {
        final TextField xField = new TextField();
        xField.setPrefColumnCount(5);

        final TextField yField = new TextField();
        yField.setPrefColumnCount(5);

        Button moveButton = new Button("Move");
        moveButton.setOnAction(actionEvent -> {
            int x = Integer.parseInt(xField.getText());
            int y = Integer.parseInt(yField.getText());
            setBoxLocation(x, y);
        });

        Label xLabel = new Label("x =");
        Label yLabel = new Label("y =");

        HBox hPane = new HBox();
        hPane.getChildren().add(xLabel);
        hPane.getChildren().add(xField);
        hPane.getChildren().add(yLabel);
        hPane.getChildren().add(yField);
        hPane.getChildren().add(moveButton);
        pane.setBottom(hPane);
    }

    public void setBoxLocation(int x, int y) {
        /* Animazione
        TranslateTransition translate = new TranslateTransition(Duration.millis(700));
        translate.setToX(x);
        translate.setToY(y);
        ParallelTransition t = new ParallelTransition(box, translate);
        t.play();
        */
        box.setTranslateX(x);
        box.setTranslateY(y);
    }

    public Scene getScene() {
        return scene;
    }


}
